import java.net.*;

import java.io.IOException;

import java.io.PrintStream;



//==========================================================================

// UDPUtils           (C) Oct 1996 Laurence Vanhelsuwe - All Rights Reserved

// --------

// This class contains some utility functions for UDP data communication:

//  static   void    sendUDP (byte[] msg, String host, int portNumber)

//  static byte[] receiveUDP (int numBytes, int portNumber)

// 

// History:

// --------

// 29-Oct-96: started this file from new.java

//

// Author email: lva@telework.demon.co.uk

//==========================================================================



public class UDPUtils {



static boolean      verbose = false;



static PrintStream  o = System.out;     // convenient shorthand



//----------------------------------------------------------------------

// Send a byte array as a UDP packet to some host & port.

//----------------------------------------------------------------------

public static void sendUDP (byte[] msg, String host, int portNumber)

    throws  SocketException, IOException, UnknownHostException {



DatagramSocket  dgSocket;

DatagramPacket  datagram;

InetAddress     destination;



    dgSocket    = new DatagramSocket();

    if(verbose) o.println("Send Socket: " + dgSocket);

    if(verbose) o.println("Send Socket #: " + dgSocket.getLocalPort());



    destination = InetAddress.getByName( host );

    if(verbose) o.println("Destination: " + destination);

    if(verbose) o.println("Destination port #: " + portNumber);



    datagram    = new DatagramPacket(msg, msg.length, destination, portNumber);

    if(verbose) o.println("Ready to send " + msg.length + " bytes (" + datagram);

    dgSocket.send(datagram);



    if(verbose) o.println("Datagram sent");

    dgSocket.close();

}



//----------------------------------------------------------------------

// Receive a UDP packet from a local UDP port, as an array of bytes.

//----------------------------------------------------------------------

public static byte[] receiveUDP (int numBytes, int portNumber)

    throws SocketException, IOException {



DatagramSocket  dgSocket;

DatagramPacket  datagram;

byte[]          msg = new byte[numBytes];



    dgSocket    = new DatagramSocket( portNumber );

    if(verbose) o.println("Receive Socket: " + dgSocket);

    if(verbose) o.println("Receive Socket #: " + dgSocket.getLocalPort());



    datagram    = new DatagramPacket(msg, msg.length);

    if(verbose) o.println("Ready to receive.." + numBytes + " bytes");

    dgSocket.receive(datagram);



    dgSocket.close();

    return datagram.getData();

}

//----------------------------------------------------------------------

//----------------------------------------------------------------------

public static void setVerbose(boolean state) {

    verbose = state;

}

} // End of Class UDPUtils

